"""
by Dominic Pezzuto
"""

import GameStarter
from shmupClasses import *
import pygame
import time
import sys

GameStarter.init(screensize = (640,480), name = "SHMUP in progress", fps = 45 )

######################
## Global Variables ##
######################

#pictures
pinesquare = pygame.image.load("pine.png").convert_alpha()
tombstone = pygame.image.load("tombstone.png").convert_alpha()

redsquare = pygame.image.load("red.jpg").convert()

fatship1 = pygame.image.load("fshiptemp.png").convert_alpha()
fatship1.set_colorkey( (255,0,0) )

zipper1 = pygame.image.load("zipper.png").convert_alpha()

starBGpic = pygame.image.load("stars.png").convert()
starBGpic.set_alpha(180)

starBGtile = GameStarter.Tile(image = starBGpic)

starBG = GameStarter.TileMap(GameStarter.screen, tileWidth = 640, \
                             tileHeight = 480, vWrap = True)
starBG.tiles[0]=starBGtile
starBG.setMap([[0]])

zipperBullet1 = pygame.image.load("bullet.png").convert_alpha()

##a =  pygame.surfarray.array3d(redsquare)
##
##f = open("hey.txt","w")
##f.write(str(a))
##f.write("***")
##f.write(str(a+1))
##f.close()
##
##b = a+ 1
##
##fatship1 = pygame.surfarray.make_surface(b)


#Frames
fatshipFrames = {}
fatshipFrames["idle"] = [ fatship1 ]

playerFrames = {}
playerFrames["idle"] = [pinesquare]

zipperFrames = {}
zipperFrames["idle"] = [zipper1]

zipperBulletFrameSet = {}
zipperBulletFrameSet["idle"] = [zipperBullet1]

#Level stuff
levelCounter = 0
currentLevel = {}

#------------------------------------------------------------------
#Enemies

#currentLevel[0] = [ FatShip( [450.0,150.1], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]

currentLevel[100] = [ Zipper( [-50,-50], pattern = patternDR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[110] = [ Zipper( [-50,-50], pattern = patternDR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[120] = [ Zipper( [-50,-50], pattern = patternDR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[130] = [ Zipper( [-50,-50], pattern = patternDR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]



currentLevel[250] = [ FatShip( [400.0,-50], pattern = patternDFast, hp = 50, frameset = fatshipFrames )]


currentLevel[300] = [ Zipper( [690,-50], pattern = patternDL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[310] = [ Zipper( [690,-50], pattern = patternDL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[320] = [ Zipper( [690,-50], pattern = patternDL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[330] = [ Zipper( [690,-50], pattern = patternDL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]

currentLevel[450] = [ FatShip( [200.0,-50], pattern = patternDFast, hp = 50, frameset = fatshipFrames )]



currentLevel[700] = [ Zipper( [-50,-50], pattern = patternDR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[710] = [ Zipper( [-50,-50], pattern = patternDR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[720] = [ Zipper( [-50,-50], pattern = patternDR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[730] = [ Zipper( [-50,-50], pattern = patternDR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[700] += [ Zipper( [690,-50], pattern = patternDL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[710] += [ Zipper( [690,-50], pattern = patternDL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[720] += [ Zipper( [690,-50], pattern = patternDL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[730] += [ Zipper( [690,-50], pattern = patternDL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]

currentLevel[800] = [ FatShip( [200.0,-50], pattern = patternDFast, hp = 50, frameset = fatshipFrames )]
currentLevel[800] += [ FatShip( [400.0,-50], pattern = patternDFast, hp = 50, frameset = fatshipFrames )]

currentLevel[800] = [ Zipper( [-50,530], pattern = patternUR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[810] = [ Zipper( [-50,530], pattern = patternUR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[820] = [ Zipper( [-50,530], pattern = patternUR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[830] = [ Zipper( [-50,530], pattern = patternUR, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[800] += [ Zipper( [690,530], pattern = patternUL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[810] += [ Zipper( [690,530], pattern = patternUL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[820] += [ Zipper( [690,530], pattern = patternUL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]
currentLevel[830] += [ Zipper( [690,530], pattern = patternUL, frameset = zipperFrames, bulletFrameset = zipperBulletFrameSet )]


currentLevel[800] += [ FatShip( [30.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[800] += [ FatShip( [170.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[800] += [ FatShip( [320.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[800] += [ FatShip( [470.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]

currentLevel[1100] = [ FatShip( [30.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1100] += [ FatShip( [170.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1100] += [ FatShip( [320.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1100] += [ FatShip( [470.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]

currentLevel[1400] = [ FatShip( [30.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1400] += [ FatShip( [170.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1400] += [ FatShip( [320.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1400] += [ FatShip( [470.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]

currentLevel[1700] = [ FatShip( [30.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1700] += [ FatShip( [170.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1700] += [ FatShip( [320.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[1700] += [ FatShip( [470.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]

currentLevel[2000] = [ FatShip( [30.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[2000] += [ FatShip( [170.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[2000] += [ FatShip( [320.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]
currentLevel[2000] += [ FatShip( [470.0,-50], pattern = patternDSlow, hp = 100, frameset = fatshipFrames )]







#------------------------------------------------------------------

player = Player(startpos = [300,350])
player.frames = playerFrames

##activeSprites = pygame.sprite.Group()
activeSprites.add(player)
##
##enemies = pygame.sprite.Group()
##bullets = pygame.sprite.Group()

endP = [10,10]


#############################
## End of Global Variables ##
#############################


def eventHandler(event):
    global player, bullets
    
    if event.type == pygame.MOUSEBUTTONDOWN:
        player.lazerOffset = [0,0]
        player.lazerCurveMidpointOffset = [0,0]
    elif event.type == pygame.MOUSEBUTTONUP:
        print len(bullets)
        player.lazerPoints = [0,0]        
        lazerSprites.empty()
        

def logic():
    global player, activeSprites, endP, enemies, lazerSprites, currentLevel, levelCounter, bullets, starBG

    if currentLevel.has_key(levelCounter):
        for enemy in currentLevel[levelCounter]:
            enemies.add(enemy)

    if GameStarter.isPressed("a"):
        player.moveSpaces(-1,0)
    elif GameStarter.isPressed("d"):
        player.moveSpaces(1,0)

    if GameStarter.isPressed("w"):
        player.moveSpaces(0,-1)
    elif GameStarter.isPressed("s"):
        player.moveSpaces(0,1)

    if GameStarter.isPressed("UP"):
        endP[1] -= 1
    elif GameStarter.isPressed("DOWN"):
        endP[1] += 1        

    if GameStarter.isPressed("LEFT"):
        endP[0] -= 1
    elif GameStarter.isPressed("RIGHT"):
        endP[0] += 1


    rel = pygame.mouse.get_rel()

    activeSprites.update()
    enemies.update()
    bullets.update()


    #Build points for lazer beam
    #player.lazerOffset[0] += (rel[0])
    if pygame.mouse.get_pressed()[0] == 1:
        
        player.lazerCurveMidpointOffset[0] += 2*rel[0]        
        if player.lazerCurveMidpointOffset[0] < -250:            
            player.lazerCurveMidpointOffset[0] = -250            
        if player.lazerCurveMidpointOffset[0] > 250:
            player.lazerCurveMidpointOffset[0] = 250

        player.lazerCurveMidpointOffset[1] += rel[1]        
	try:
	        player.buildLazer()
	except:
		pass



    #Check if you have hit any enemies, and react accordingly
    #This will damage the hit enemy/s, and shorten your lazer beam if applicable
    enemyLazerCollisions = pygame.sprite.groupcollide(enemies, lazerSprites, False, False)

    if len(enemyLazerCollisions)>0:
        closestEnemy = enemyLazerCollisions.keys()[0]

        for enemy in enemyLazerCollisions.keys():
            if enemy.rect[1] > closestEnemy.rect[1]:
                closestEnemy = enemy

        temp = []

        for point in player.lazerPoints:
            if point[1]>=closestEnemy.rect[1] + closestEnemy.image.get_height():
                temp += [point]
            else:
                spriteToCheck = pygame.sprite.Sprite()
                spriteToCheck.rect = pygame.Rect([point[0]-5, point[1]-5, 10, 10])
                groupToCheck = pygame.sprite.GroupSingle(sprite=closestEnemy)
                if pygame.sprite.spritecollideany(spriteToCheck, groupToCheck):
                    break
                else:
                    temp += [point]
            
        player.lazerPoints = temp

        closestEnemy.health -= player.lazerDamage

        closestEnemy.whitealpha += 1

        if closestEnemy.health <= 0:
            closestEnemy.destroy()   


        
    #Check player collisions, to see if you have been hit
    if pygame.sprite.spritecollideany(player, enemies) or pygame.sprite.spritecollideany(player, bullets):
        print "Dead!"
	playerFrames["idle"] = [tombstone]
        #pygame.quit()
        #sys.exit()

##    if player.lazerWidth < player.lazerWidthMax:
##        player.lazerWidth += .5
        
    starBG.scroll(0,1)
    levelCounter += 1

def drawing():
    global player, activeSprites, enemies, bullets, starBG

    #GameStarter.screen.fill( (0, 0, 0) )

    starBG.draw()
    
    if len(player.lazerPoints) > 2:
        player.drawLazer()

    activeSprites.draw(GameStarter.screen)
    enemies.draw(GameStarter.screen)
    bullets.draw(GameStarter.screen)        


GameStarter.eventHandler = eventHandler
GameStarter.logic = logic
GameStarter.drawing = drawing

pygame.key.set_repeat(1,0)
##pygame.mouse.set_visible(False)

while True:
    beg = time.time()    
    GameStarter.mainloop()
    pygame.mouse.get_rel()
##    print GameStarter.clock.get_fps()
##    print time.time() - beg
##    print "--"

##x = 0.0
##for i in range(21):
##    print player.getLazerCurvePoint(x, (0,0), (5,5), (10,0))
##    x += 0.05
    
